package com.fzm.common.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.fzm.common.entity.Order;
import com.fzm.common.entity.dto.OrderDto;
import com.fzm.common.entity.vo.OrderVo;
import com.fzm.common.enums.OrderStatus;

import java.util.List;

/**
 * @author tangtuo
 * @date 2022/1/19 15:41
 */
public interface OrderService extends IService<Order> {

    /**
     * 根据支付场景和产品id查询订单
     *
     * @param payScene
     * @param productId
     * @return
     */
    Order getByPaySceneAndProductId(Integer payScene, Integer productId, Integer orderStatus);

    /**
     * 更新订单状态
     *
     * @param out_trade_no
     * @param orderStatus
     */
    void updateOrderStatus(Long out_trade_no, OrderStatus orderStatus);

    /**
     * 下单
     *
     * @param orderDto
     * @return
     */
    Long createOrder(OrderDto orderDto);

    /**
     * @param orderId
     * @param payType
     */
    Boolean updatePayType(Long orderId, Integer payType);

    /**
     * 取消订单
     *
     * @param orderId
     * @param orderStatus
     * @return
     */
    Boolean cancel(Long orderId);

    /**
     * 获取我的订单
     *
     * @param payScene
     * @return
     */
    List<OrderVo> listOrder(Integer payScene);

    void processOrder(Long orderId, Integer productId, Integer payScene);
}
